/*==============================================================================
GBxCoop, copyright by Alam Ed Arias
Build On Joss Liu's JCoop4.JCoopGame
Build 00 I made the server change HUD by Admin set, that was dumd
Build 01 Added Configable Tags, Logable Server Console Say And 8 Admin Passwords
Build 02 OverFlow Jcoop's Login to able to put in GBxMM_Playerpawns and alot of stuff
==============================================================================*/
class GBxCoopGame extends JCoopGame ;

var(GameControl) private globalconfig string AdminPassword[8];// Password to receive bAdmin privileges.
var(GameControl) private globalconfig string GamePassword;	// Password to enter game.
var(GameControl) private config string FullSvrPass; // allow logins to a full server

//var(Misc) config string ServerName;	// Name Of Server

var(TheMatrix) config float MaxWallrunTime, MaxFreezeTime, WallRunSpeed;
var(TheMatrix) config Array<string> BossLevels; //Levels to do Matrix
var(TheMatrix) config bool bMMAllMap; //Do all Maps
var(TheMatrix) bool bMMThisMap; //This Map to do
var(TheMatrix) private config string MMPass;	// Password to alway have MM_Player
var(TheMatrix) bool bMMPass; // able to use MMPass
var(TheMatrix) string VersionNumber, VersionDate; //Info
var(TheMatrix) class<playerpawn>       DefaultMMPlayerClass;

struct GBxScoreEntry
{
    var int DeathEnemyKills;
    var int MaxSpree;
};

var GBxScoreEntry			GBxScoreTable[64];

CONST MIN_TIME = 0;
CONST MAX_TIME = 999;
CONST MIN_WALLRUNSPEED = 0.1;
const MAX_WALLRUNSPEED = 2;



//==============================================================================
function PostBeginPlay()
{
    local int i, j;
    local string thisMap, MMList,next;
    log("GBxCooop, Add-on for JCoop, Up And Running", 'GBx');
	super.PostBeginPlay();
	ValidateValues();
    MaxWallRuntime = Default.MaxWallRuntime;
	MaxFreezeTime = Default.MaxFreezeTime;
	WallRunSpeed = Default.WallRunSpeed;

    //check for MM list
    MMlist = GetPropertyText("BossLevels");
	// strip the parens
	MMlist = Mid(MMlist, 1, Len(MMlist) - 2);

	// get name of this map
	thisMap = Level.GetLocalURL(); // 0.0.0.0/dig?Name=....
	i = InStr(thisMap, "/") + 1;
	j = InStr(thisMap, "?");
	thisMap = Mid(thisMap, i, j-i);

	// see if we have a match for thismap
	log("CustomMMMap list:"@MMlist, 'GBx');
	log("thisMap:"@thisMap, 'GBx');
	// this shold work, so the time to do this will drop
    if(bMMAllMap)
        bMMthisMap = true;

	while((gobble(next, MMlist)) && !bMMThisMap)
	{
		if(thisMap ~= next)
		{
			bMMThisMap = true;
		}
	}

} // PostBeginPlay()

static function ValidateValues()
{
	//let check min and max values
    Default.MaxWallRuntime = FMin(MAX_TIME, FMax(MIN_TIME, Default.MaxWallrunTime));
	Default.MaxFreezeTime = FMin(MAX_TIME, FMax(MIN_TIME, Default.MaxFreezeTime));
	Default.WallRunSpeed = FMin(MAX_WALLRUNSPEED, FMax(MIN_WALLRUNSPEED, Default.WallRunSpeed));
}


function bool RestartPlayer( pawn p )
{
	//let send Gbxcoop values to the players
    if(p.IsA('GBxMM_PlayerPawn'))
    {
	   	GBxMM_PlayerPawn(p).MaxWallrunTime = MaxWallrunTime;
      	GBxMM_PlayerPawn(p).MaxFreezeTime = MaxFreezeTime;
	   	GBxMM_PlayerPawn(p).WallRunSpeed = WallRunSpeed;
    	GBxMM_PlayerPawn(p).ResetMMVars();
	}
    return super.RestartPlayer(p);
}

function AddDefaultInventory(Pawn p)
{
	super.AddDefaultInventory(p);
	if(bSetHealth)
	{
		if((p.IsA('GBxNaliPlayer'))||(p.IsA('GBxMM_NaliPlayer')))         // default 80
		{
			if(p.Health < 0.8 * iBaseHealth)
				p.Health = 0.8 * iBaseHealth;
			if(p.Health > 2.0 * 0.8 * iBaseHealth)
				p.Health = 2.0 * 0.8 * iBaseHealth;
		}
		else if((p.IsA('GBxHuman'))||(p.IsA('GBxMM_Human')))               // default 100
		{
			if(p.Health < 1.0 * iBaseHealth)
				p.Health = 1.0 * iBaseHealth;
			if(p.Health > 2.0 * 1.0 * iBaseHealth)
				p.Health = 2.0 * 1.0 * iBaseHealth;
		}
		else if((p.IsA('GBxSkaarjPlayer'))||(p.IsA('GBxMM_SkaarjPlayer')))// default 130
		{
			if(p.Health < 1.3 * iBaseHealth)
				p.Health = 1.3 * iBaseHealth;
			if(p.Health > 2.0 * 1.3 * iBaseHealth)
				p.Health = 2.0 * 1.3 * iBaseHealth;
		}
	}
} // AddDefaultInventory()

event PlayerPawn Login( string Portal,
						string Options,
						out string Error,
						class<PlayerPawn> SpawnClass)
{
	//man, do i wish this code don't had to be overloaded
    local NavigationPoint	StartSpot;
	local PlayerPawn		newPlayer, TestPlayer;
	local Pawn				PawnLink;
	local string			InName, InPassword, InSkin, InFace;
	local string			DesiredClass; // player's desired class
	local byte				InTeam;
	local int				i;

    local string            InMMpass; //MMPass from playerpawn login url
    local bool              bNeo; // I am the one

	local string			tmpPlayerName, tmpTeamName;
	local int				tmpID;
	local byte				tmpTeam;
	local int				tmpTeamID;
	local class<VoicePack>	tmpVoiceType;
	local bool				tmpbIsABot, tmpbIsSpectator, bLetMeIn;
	local texture			tmpTalkTexture;
	local ZoneInfo			tmpPlayerZone;

	// Make sure there is capacity. (This might have changed since the PreLogin call).
	InPassword = ParseOption(Options, "FullSvrPass");
	if(bFullSvrLogin &&
			FullSvrPass != "" &&
			caps(InPassword) == caps(FullSvrPass))
		bLetMeIn = true;

	if((Level.NetMode != NM_Standalone) && (MaxPlayers>0) && (NumPlayers>=MaxPlayers) && !bLetMeIn)
	{
		Error = MaxedOutMessage;
		if(bCastFailedLogin)
			AMsg(InName@"failed login:"@"("$Error$")");
		return None;
	}

	// Get URL options.
	InName     = Left(ParseOption ( Options, "Name"), 20);
	InTeam     = GetIntOption( Options, "Team", 255 ); // default to "no team"
	InPassword = ParseOption ( Options, "Password" );
	InSkin	   = ParseOption ( Options, "Skin"    );
	InFace     = ParseOption ( Options, "Face"    );

    // I Have "The One" Pass
	InMMpass   = ParseOption ( Options, "MMPass"  ); //new password
	if(bMMPass && MMPass != "" && caps(InMMpass) == caps(MMPass))
		bNeo = true;

	log("Login:" @ InName, 'GBxCoop');
	if(InPassword != "")
		log("Password"@InPassword, 'GBxCoop');

	/*	224/225 is capable of sending an Options string with spaces. Gold seems to
		forbid such, and presumably so does 226f patch. The Gold server somehow
		truncates the Options string at the first space, and then crashes on the
		shortened Options string (seen in my gold log:
		DevNet: Level server received: LOGIN RESPONSE=-667909588 URL=Index.unr?Name=bill gates?Class=UnrealShare.MaleThree?Skin=Male3Skins.Dante?Team=255?Face=
		DevNet: Login request: Index.unr?Name=bill
		After this the server crashes. We will examine the Options string and
		provide some sane fillers for missing parts that might make engine crash.
	*/

	// Assuming at least "?Name=xxxx"
	if(!HasOption(Options,"class"))
	{
		log("Login(): Player has no PlayerClass, giving DefaultPlayerClass.", 'GBxCoop');
		Options=Options$"?Class="$DefaultPlayerClass.Name;
		SpawnClass = DefaultPlayerClass;
	}
	// LOL! This next line will crash game if ?Class=something is not in Options
	DesiredClass = Left(ParseOption(Options, "Class"), 30);
	i = InStr(DesiredClass, ".");
	if(i != -1)
		DesiredClass = Mid(DesiredClass, i+1);

	// entering playerclass that is not allowed
	if(!ClassIsChildOf(SpawnClass, class'UnrealIPlayer') &&
		!ClassIsChildOf(SpawnClass, class'UnrealSpectator'))
	{
		// not a ChildOf(playerpawn)... so just kick. really should never get here!
		log("Player:"$InName@"trying to use:"$SpawnClass, 'GBxCoop');
		Error = "Player attmepting use of non-PlayerPawn class: kicked";
		if(bCastFailedLogin)
			AMsg(InName@"failed login:"@"("$Error$")");
		return None;
	}
    // do i have to Overload Joss's Login manly to justs do this?, *sigh*
	//{
	   if (bMMThisMap || bNeo || bMMAllMap)
       {
            if(DesiredClass ~= (string(SpawnClass.name)))
    	   {
        		if((DesiredClass ~= "UPakFemaleOne") || (DesiredClass ~= "FemaleOne"))
        			SpawnClass = class'GBxMM_FemaleOne';
        		else if((DesiredClass ~= "UPakFemaleTwo") || (DesiredClass ~= "FemaleTwo"))
        			SpawnClass = class'GBxMM_FemaleTwo';
        		else if((DesiredClass ~= "UPakMaleOne") || (DesiredClass ~= "MaleOne"))
        			SpawnClass = class'GBxMM_MaleOne';
        		else if((DesiredClass ~= "UPakMaleTwo") || (DesiredClass ~= "MaleTwo"))
            		SpawnClass = class'GBxMM_MaleTwo';
           		else if((DesiredClass ~= "UPakMaleThree") || (DesiredClass ~= "MaleThree"))
           			SpawnClass = class'GBxMM_MaleThree';
           		else if(DesiredClass ~= "SkaarjPlayer")
           			SpawnClass = class'GBxMM_SkaarjPlayer';
        		else if(DesiredClass ~= "naliplayer")
        			SpawnClass = class'GBxMM_NaliPlayer';
        		else if(DesiredClass ~= "UnrealSpectator")
        			SpawnClass = class'GBxSpectator';
        		else
        			SpawnClass = DefaultMMPlayerClass;
        	}
        	else // DesiredClass doesn't match SpawnClass
        	{
        		if(DesiredClass ~= "UPakFemaleOne")
        			SpawnClass = class'GBxMM_FemaleOne';
        		else if(DesiredClass ~= "UPakFemaleTwo")
        			SpawnClass = class'GBxMM_FemaleTwo';
        		else if(DesiredClass ~= "UPakMaleOne")
        			SpawnClass = class'GBxMM_MaleOne';
        		else if(DesiredClass ~= "UPakMaleTwo")
        			SpawnClass = class'GBxMM_MaleTwo';
        		else if(DesiredClass ~= "UPakMaleThree")
        			SpawnClass = class'GBxMM_MaleThree';
        		else
        			SpawnClass = DefaultMMPlayerClass;
    	   }
    	}
    	else
    	   {
        	   if(DesiredClass ~= (string(SpawnClass.name)))
            	{
        		if((DesiredClass ~= "UPakFemaleOne") || (DesiredClass ~= "FemaleOne"))
        			SpawnClass = class'GBxFemaleOne';
        		else if((DesiredClass ~= "UPakFemaleTwo") || (DesiredClass ~= "FemaleTwo"))
		          	SpawnClass = class'GBxFemaleTwo';
        		else if((DesiredClass ~= "UPakMaleOne") || (DesiredClass ~= "MaleOne"))
        			SpawnClass = class'GBxMaleOne';
        		else if((DesiredClass ~= "UPakMaleTwo") || (DesiredClass ~= "MaleTwo"))
        			SpawnClass = class'GBxMaleTwo';
        		else if((DesiredClass ~= "UPakMaleThree") || (DesiredClass ~= "MaleThree"))
        			SpawnClass = class'GBxMaleThree';
        		else if(DesiredClass ~= "SkaarjPlayer")
        			SpawnClass = class'GBxSkaarjPlayer';
        		else if(DesiredClass ~= "naliplayer")
        			SpawnClass = class'GBxNaliPlayer';
        		else if(DesiredClass ~= "UnrealSpectator")
        			SpawnClass = class'GBxSpectator';
        		else
        			SpawnClass = DefaultPlayerClass;
           	}
        	else // DesiredClass doesn't match SpawnClass
        	{
        		if(DesiredClass ~= "UPakFemaleOne")
        			SpawnClass = class'GBxFemaleOne';
        		else if(DesiredClass ~= "UPakFemaleTwo")
        			SpawnClass = class'GBxFemaleTwo';
        		else if(DesiredClass ~= "UPakMaleOne")
        			SpawnClass = class'GBxMaleOne';
        		else if(DesiredClass ~= "UPakMaleTwo")
        			SpawnClass = class'GBxMaleTwo';
        		else if(DesiredClass ~= "UPakMaleThree")
        			SpawnClass = class'GBxMaleThree';
        		else
        			SpawnClass = DefaultPlayerClass;
        	}
   	   }

    //}
	log("Incoming Player named"@InName@"desired"@DesiredClass@"and got"@SpawnClass.name, 'GBxCoop');

	// anything at this point is a legal Unreali/UnrealShare class
// =============================================================================
//		newPlayer = Super.Login(Portal, Options, Error, SpawnClass);
// GameInfo.Login() stuff, molested... this is why we need our own AdminPassword
// and GamePassword, since they are defined as private in GameInfo

	// Find a start spot.
	StartSpot = FindPlayerStart(inteam, Portal);

	if(StartSpot == None)
	{
		Error = FailedPlaceMessage;
		if(bCastFailedLogin)
			AMsg(InName@"failed login:"@"("$Error$")");
		return None;
	}
/* hmmmm.... this block was commented out for jcoop3 & 4 */
	// Try to match up to existing unoccupied player in level,
	// for savegames and coop level switching.
	for( PawnLink=Level.PawnList; PawnLink!=None; PawnLink=PawnLink.NextPawn )
	{
		TestPlayer = PlayerPawn(PawnLink);
		if
		(TestPlayer != None && TestPlayer.Player == None )
		{
			if
			((Level.NetMode == NM_Standalone) ||
			(TestPlayer.PlayerReplicationInfo.PlayerName ~= InName &&
			TestPlayer.Password ~= InPassword))
			{
				// Found matching unoccupied player, so use this one.
				NewPlayer = TestPlayer;
				break;
			}
		}
	}
/* end block comment -- for jcoop5 testing */

	// In not found, spawn a new player.
	if(NewPlayer == none)
	{
		// Make sure this kind of player is allowed.
		if((bHumansOnly || Level.bHumansOnly) && !SpawnClass.Default.bIsHuman &&
				!ClassIsChildOf(SpawnClass, class'Spectator'))
			SpawnClass = DefaultPlayerClass;

		if((NumSpectators >= MaxSpectators) &&
			ClassIsChildOf(SpawnClass, class'Spectator'))
		{
			Error="Max spectators exceeded";
			if(bCastFailedLogin)
				AMsg(InName@"failed login:"@"("$Error$")");
			return None;
		}

		NewPlayer = Spawn(SpawnClass,,,StartSpot.Location,StartSpot.Rotation);
		if( NewPlayer!=None )
			NewPlayer.ViewRotation = StartSpot.Rotation;
	}

	// Handle spawn failure.
	if(NewPlayer == None)
	{
		log("Couldn't spawn player at "$StartSpot, 'GBxCoop');
		log("Login() -- newPlayer=None", 'GBxCoop');
		Error = FailedSpawnMessage;
		if(bCastFailedLogin)
			AMsg(InName@"failed login:"@"("$Error$")");
		return None;
	}
	if(!NewPlayer.IsA('GBxPlayerPawn') && !NewPlayer.IsA('GBxSpectator')) // does this ever happen?
	{
		NewPlayer.Destroy();
		Error = "Not proper playerclass (not GBxPlayerPawn or not GBxSpectator)! Please try again.";
		if(bCastFailedLogin)
			AMsg(InName@"failed login:"@"("$Error$")");
		return none;
	}
	else if(GBxPRI(NewPlayer.PlayerReplicationInfo) == none)
	{
		log("Player entered without GBxPRI!", 'GBxCoop');
		// somehow didn't get the right PRI (see this rarely...) so give a new one
		// get my new GBxPRI PlayerReplcationInfo extension
		if(newPlayer.PlayerReplicationInfo == none)
		{
			// no PRI at all?
			Error = "No PRI at all! Please try again.";
			if(bCastFailedLogin)
				AMsg(InName@"failed login:"@"("$Error$")");
			NewPlayer.Destroy();
			return none;
		}
		else
		{
			// save the regular PRI info
			tmpPlayerName = newPlayer.PlayerReplicationInfo.PlayerName;
			tmpTeamName = newPlayer.PlayerReplicationInfo.TeamName;
			tmpID = newPlayer.PlayerReplicationInfo.PlayerID;
			tmpTeam = newPlayer.PlayerReplicationInfo.Team;
			tmpTeamID = newPlayer.PlayerReplicationInfo.TeamID;
			tmpVoiceType = newPlayer.PlayerReplicationInfo.VoiceType;
			tmpbIsABot = newPlayer.PlayerReplicationInfo.bIsABot;
			tmpbIsSpectator = newPlayer.PlayerReplicationInfo.bIsSpectator;
			tmpTalkTexture = newPlayer.PlayerReplicationInfo.TalkTexture;
			tmpPlayerZone = newPlayer.PlayerReplicationInfo.PlayerZone;

			// get rid of old PRI and spawn a new JCPRI
			newPlayer.PlayerReplicationInfo.Destroy();
			newPlayer.PlayerReplicationInfo = spawn(class'GBxPRI', newPlayer);
			newPlayer.PlayerReplicationInfoClass = class'GBxPRI';

			// restore the PRI values to JCPRI
			newPlayer.PlayerReplicationInfo.PlayerName = tmpPlayerName;
			newPlayer.PlayerReplicationInfo.TeamName = tmpTeamName;
			newPlayer.PlayerReplicationInfo.PlayerID = tmpID;
			GBxPRI(newPlayer.PlayerReplicationInfo).PlayerID = tmpID;
			newPlayer.PlayerReplicationInfo.Team = tmpTeam;
			newPlayer.PlayerReplicationInfo.TeamID = tmpTeamID;
			newPlayer.PlayerReplicationInfo.VoiceType = tmpVoiceType;
			newPlayer.PlayerReplicationInfo.bIsABot = tmpbIsABot;
			newPlayer.PlayerReplicationInfo.bIsSpectator = tmpbIsSpectator;
			newPlayer.PlayerReplicationInfo.TalkTexture = tmpTalkTexture;
			newPlayer.PlayerReplicationInfo.PlayerZone = tmpPlayerZone;
			JCPRI(newPlayer.PlayerReplicationInfo).bAdmin = newPlayer.bAdmin;
		}
	} // PRI replacement

//		if(InSkin != "")
	NewPlayer.static.SetMultiSkin(NewPlayer, InSkin, InFace, InTeam);

	if(!ChangeTeam(newPlayer, InTeam))
	{
		Error = FailedTeamMessage;
		if(bCastFailedLogin)
			AMsg(InName@"failed login:"@"("$Error$")");
		return None;
	}

	if(NewPlayer.IsA('Spectator') && (Level.NetMode == NM_DedicatedServer))
		NumSpectators++;

	// Init player's administrative privileges
	// new: 2 admin levels - TmpAdmin, Admin. bAdmin is set for both levels
	// TmpAdmin has some restrictions
	NewPlayer.Password = InPassword;
	for(i = 0; i < ArrayCount(AdminPassword); i++)
		if(AdminPassword[i] != "" && caps(InPassword) == caps(AdminPassword[i]))
		{
			NewPlayer.bAdmin = true;
			break;
		}
	if(NewPlayer.bAdmin && i!=0)
		jPlayerPawn(NewPlayer).bTmpAdmin = true;

	if( NewPlayer.bAdmin )
		log("Administrator logged in", 'GBxCoop');
	if(jPlayerPawn(newPlayer).bTmpAdmin)
		log("*** Temp Admin ***", 'GBxCoop');

	// Init player's information.
	NewPlayer.ClientSetRotation(NewPlayer.Rotation);

	// Set the player's ID.
	NewPlayer.PlayerReplicationInfo.PlayerID = CurrentID++;
	JCPRI(newPlayer.PlayerReplicationInfo).PlayerID =
		newPlayer.PlayerReplicationInfo.PlayerID;

	if(InName=="" || InName~=defaultPlayerName)
		InName=DefaultPlayerName$newPlayer.PlayerReplicationInfo.PlayerID;
	if(Level.NetMode!=NM_Standalone ||
			NewPlayer.PlayerReplicationInfo.PlayerName~=DefaultPlayerName )
		ChangeName(NewPlayer, InName, false);

	// Init player's replication info
	NewPlayer.GameReplicationInfo = GameReplicationInfo;

	// If we are a server, broadcast a welcome message.
	if( Level.NetMode==NM_DedicatedServer || Level.NetMode==NM_ListenServer )
		BroadcastMessage( NewPlayer.PlayerReplicationInfo.PlayerName$EnteredMessage, false );

	// Teleport-in effect.
	StartSpot.PlayTeleportEffect( NewPlayer, true );

	// Log it.
	if ( LocalLog != None )
		LocalLog.LogPlayerConnect(NewPlayer);
	if ( WorldLog != None )
		WorldLog.LogPlayerConnect(NewPlayer);

// =============================================================================
// CoopGame.Login() stuff, molested
	if(!NewPlayer.IsA('Spectator'))
	{
		NumPlayers++;
		NewPlayer.bHidden = false;
		NewPlayer.SetCollision(true,true,true);
	}
	log("Logging in to "$Level.Title, 'GBxCoop');
	if(Level.Title ~= "The Source Antechamber")
	{
		bSpecialFallDamage = true;
		log("reduce fall damage", 'GBxCoop');
	}

	return newPlayer;
} // Login()

simulated event PostLogin(PlayerPawn p)
{
	local int i;
	local bool bInTable;

	// make an announcement about player logging in
	if(bShowAdmins && p.bAdmin)
		broadcastmessage(p.PlayerReplicationInfo.PlayerName@"is Admin");
	if(p.IsA('Spectator'))
		broadcastmessage(p.PlayerReplicationInfo.PlayerName@"is spectating");

	// see if we have a score table entry for this player
	i=0;
	while(ScoreTable[i].PlayerName != "" && i<ArrayCount(ScoreTable))
	{
		if(p.PlayerReplicationInfo.PlayerName == ScoreTable[i].PlayerName)
		{
			bInTable = true;
			JCPRI(p.PlayerReplicationInfo).STI = i;
			if(bKeepScores)
			{
				p.PlayerReplicationInfo.Score = ScoreTable[i].Score;
				JCPRI(p.PlayerReplicationInfo).EnemyKillCount = ScoreTable[i].EnemyKills;
				JCPRI(p.PlayerReplicationInfo).FriendKillCount = ScoreTable[i].FriendKills;
				JCPRI(p.PlayerReplicationInfo).DeathCount = ScoreTable[i].Deaths;
				JCPRI(p.PlayerReplicationInfo).SuicideCount = ScoreTable[i].Suicides;
				JCPRI(p.PlayerReplicationInfo).bMute = ScoreTable[i].bMute;
				GBxPRI(p.PlayerReplicationInfo).DeathEnemyKillCount = GBxScoreTable[i].DeathEnemyKills;
				GBxPRI(p.PlayerReplicationInfo).GBxSpree = GBxScoreTable[i].MaxSpree;
                Log("PostLogin(): Score restored for"@i$":"@p.PlayerReplicationInfo.PlayerName, 'GBxCoop');
			}
			break;
		}
		i++;
	}
	if(!bInTable && i<ArrayCount(ScoreTable))
	{
		ScoreTable[i].PlayerName = p.PlayerReplicationInfo.PlayerName;
		JCPRI(p.PlayerReplicationInfo).STI = i;
		log("PostLogin(): Score entry added:"@i@ScoreTable[i].PlayerName, 'GBxCoop');
	}
/*	// not in table, and table full, so find LRU entry to replace
	else
	{
		OldestEntry = 0;
		for(i=0; i<ArrayCount(ScoreTable); i++
		{
			if(ScoreTable[i].LOTime < ScoreTable[OldestEntry].LOTime)
				OldestEntry = i;
		}
		// should we check to see if i is in use by another player?
		ScoreTable[OldestEntry].PlayerName = p.PlayerReplicationInfo.PlayerName;
		JCPRI(p.PlayerReplicationInfo).STI = OldestEntry;
		// zero the score entries
		ScoreTable[OldestEntry].EnemyKills = 0;
		ScoreTable[OldestEntry].FriendKills = 0;
		ScoreTable[OldestEntry].Deaths = 0;
		ScoreTable[OldestEntry].Suicides = 0;
		ScoreTable[OldestEntry].Score = 0;
		ScoreTable[OldestEntry].bMute = false;
		log("PostLogin(): Score entry replaces oldest entry in table:"@i@ScoreTable[OldestEntry].PlayerName, 'GBxCoop');
	}
*/
	JCPRI(p.PlayerReplicationInfo).bSTIValid = true;
	LogScoreTable();

	Super.PostLogin(p);
} // PostLogin()

function ScoreKill(pawn Killer, pawn Other)
{
    //Let Add more point for deathpawn and maxspree keeping
	super.ScoreKill(Killer,Other);
    if(Killer != none && Killer.bIsPlayer)
	{
        if(Instr(caps(string(Other.name)), caps("death")) != -1)
	   {
            JCPRI(killer.PlayerReplicationInfo).EnemyKillCount += 1;
            GBxPRI(PlayerPawn(Killer).PlayerReplicationInfo).DeathEnemyKillCount += 1;
    		GBxScoreTable[JCPRI(Killer.PlayerReplicationInfo).STI].DeathEnemyKills += 1;
            ScoreTable[JCPRI(Killer.PlayerReplicationInfo).STI].EnemyKills += 1;

    		Killer.PlayerReplicationInfo.Score += 9;
    		ScoreTable[JCPRI(Killer.PlayerReplicationInfo).STI].Score += 9;

    		JCGRI(GameReplicationInfo).PlayerTotal += 9;
    		JCPRI(PlayerPawn(Killer).PlayerReplicationInfo).jSpree += 9;
    	}
    	if (JCPRI(PlayerPawn(Killer).PlayerReplicationInfo).jSpree > GBxPRI(PlayerPawn(Killer).PlayerReplicationInfo).GBxSpree)
            {
            GBxPRI(PlayerPawn(Killer).PlayerReplicationInfo).GBxSpree = JCPRI(PlayerPawn(Killer).PlayerReplicationInfo).jSpree;
            GBxScoreTable[JCPRI(Killer.PlayerReplicationInfo).STI].MaxSpree =
                GBxPRI(Killer.PlayerReplicationInfo).GBxSpree;
            }

    }
} // ScoreKill()



//==============================================================================
// this command for use at the server console but does not works, it have to be a core thing
/*exec function Say( coerce string Msg )
{
	local Pawn P;

		for( P=Level.PawnList; P!=None; P=P.nextPawn )  // go thru pawn list
			if( P.bIsPlayer )  // looking for Players
			PlayerPawn(p).ClientMessage(ServerName$": "$Msg, 'Event', True);
		if(JCoopGame(Level.Game).bChatLog)
			log(ServerName$": "$Msg, 'ChatLog');
	    return;
} // Say()*/

defaultproperties
{
				MaxWallRunTime=5.000000
				MaxFreezeTime=3.000000
				WallRunSpeed=1.000000
				VersionNumber="Beta 4.3 for Unreal 1"
				VersionDate="05nd May 2003."
				DefaultMMPlayerClass=Class'FGH.GBxMM_NaliPlayer'
				MaxSuicides=11
				ServerTravelPause=5
				GlobalNameChange=" had rename to "
				NoNameChange="'s phone is busy, Please hang up and try agian"
				TimeMessage(0)="Ahh, 5 minutes left for this level"
				TimeMessage(1)="Hey, There 4 minutes left for this level"
				TimeMessage(2)="Get going!, There only 3 minutes left for this level"
				TimeMessage(3)="Move It! There 2 minutes left for this level"
				TimeMessage(4)="Come On! There just 1 more minute left for this level"
				TimeMessage(5)="Oh My God! 30 seconds left!"
				TimeMessage(6)="Run! There 10 seconds left!"
				TimeMessage(7)="Now 5 seconds are left and counting..."
				TimeMessage(8)="-4...-"
				TimeMessage(9)="-3...-"
				TimeMessage(10)="-2...-"
				TimeMessage(11)="-1...-"
				TimeMessage(12)="-Time Up!-"
				RapidLoginMessage="Please stop hammering the server!, Have a nice day  :) "
				KeepoutMessage="You have misbehaved and you had been disconnect from the server for the time being"
				NoNameMessage="Please enter a player name before joining this server, Null... ha ha"
				AdvJC="[J5b3GBx02]"
				DefaultPlayerClass=Class'FGH.GBxNaliPlayer'
				ScoreBoardType=Class'FGH.GBxScoreBoard'
				RulesMenuType="GBxCoop2Menu.GBxCoopGameRulesSClient"
				SettingsMenuType="GBxCoop2Menu.GBxCoopGameSettingsSClient"
				HUDType=Class'FGH.GBxHUD'
				GameReplicationInfoClass=Class'FGH.GBxGRI'
				LocalBatcherParams="UM27RIDZM-FEE42885674FA24E"
}
